VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "IADSDataFileInterface Test Script"
   ClientHeight    =   4065
   ClientLeft      =   2040
   ClientTop       =   2460
   ClientWidth     =   5625
   LinkTopic       =   "Form1"
   ScaleHeight     =   4065
   ScaleWidth      =   5625
   Begin VB.CommandButton outputBrowseBtn 
      Caption         =   "Browse"
      Height          =   375
      Left            =   4200
      TabIndex        =   12
      Top             =   2760
      Width           =   1095
   End
   Begin VB.TextBox outputTxt 
      Height          =   285
      Left            =   240
      TabIndex        =   11
      Text            =   "C:\Stuff"
      ToolTipText     =   "Directory to create the output CSV file"
      Top             =   2760
      Width           =   3855
   End
   Begin VB.TextBox numPtsTxt 
      Height          =   285
      Left            =   2280
      TabIndex        =   9
      Text            =   "50"
      Top             =   2040
      Width           =   1815
   End
   Begin VB.TextBox startTimeTxt 
      Height          =   285
      Left            =   240
      TabIndex        =   8
      Text            =   "-1"
      ToolTipText     =   "Enter -1 to start at the beginning of the file"
      Top             =   2040
      Width           =   1815
   End
   Begin VB.TextBox paramTxt 
      Height          =   285
      Left            =   240
      TabIndex        =   5
      Text            =   "ADC011_Ch00"
      Top             =   1320
      Width           =   3855
   End
   Begin VB.CommandButton inputBrowseBtn 
      Caption         =   "Browse"
      Height          =   375
      Left            =   4200
      TabIndex        =   4
      Top             =   600
      Width           =   1095
   End
   Begin VB.TextBox directoryTxt 
      Height          =   285
      Left            =   240
      TabIndex        =   3
      Text            =   "C:\TrainingData\Kenji Data"
      ToolTipText     =   "Directory where parameter data files reside"
      Top             =   600
      Width           =   3855
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Export Data"
      Height          =   375
      Left            =   2160
      TabIndex        =   2
      Top             =   3360
      Width           =   1335
   End
   Begin VB.Label Label5 
      Caption         =   "Output File Directory:"
      Height          =   255
      Left            =   240
      TabIndex        =   10
      ToolTipText     =   "Directory to create the output CSV file"
      Top             =   2520
      Width           =   1695
   End
   Begin VB.Label Label4 
      Caption         =   "Number of Points:"
      Height          =   255
      Left            =   2280
      TabIndex        =   7
      Top             =   1800
      Width           =   1455
   End
   Begin VB.Label Label3 
      Caption         =   "Start Time:"
      Height          =   255
      Left            =   240
      TabIndex        =   6
      ToolTipText     =   "Enter -1 to start at the beginning of the file"
      Top             =   1800
      Width           =   1215
   End
   Begin VB.Label Label2 
      Caption         =   "Parameter Name:"
      Height          =   255
      Left            =   240
      TabIndex        =   1
      Top             =   1080
      Width           =   1455
   End
   Begin VB.Label Label1 
      Caption         =   "Input Data Directory:"
      Height          =   255
      Left            =   240
      TabIndex        =   0
      ToolTipText     =   "Directory where parameter data files reside"
      Top             =   360
      Width           =   1695
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *****************************************************************************
'
' Copyright. 2008. Symvionics, Inc. All rights reserved.
'
' Symvionics Inc. ("Symvionics") grants a non-exclusive license for you to use
' this source code and the accompanying documentation, if any, free of charge,
' provided that this paragraph, and the following two paragraphs appear in all
' copies and in all derivative works.  In no event shall this source code or
' this license thereto impact upon or fall within the scope of any other
' agreement that you have with Symvionics.
'
' BY USING THIS SOFTWARE, YOU FURTHER AGREE THAT, IN NO EVENT, SHALL SYMVIONICS
' BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR
' CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS
' SOFTWARE, THE ACCOMPANYING DOCUMENTATION, IF ANY, OR ANY DERIVATIVE WORKS.
' YOU AGREE TO DEFEND, INDEMNIFY, AND HOLD HARMLESS SYMVIONICS FROM AND AGAINST
' ALL FINES, PENALTIES, LIABILITIES, DAMAGES, COSTS, AND EXPENSES INCURRED
' BY SYMVIONICS AS A RESULT OF YOUR USE OF THIS SOFTWARE INCLUDING THIRD PARTY
' USE OF ANY DERIVATIVE WORKS CREATED BY YOU.
'
' SYMVIONICS SPECIFICALLY DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING, BUT NOT
' LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
' PARTICULAR PURPOSE.  THE SOFTWARE AND ACCOMPANYING DOCUMENTATION LICENSED
' HEREUNDER ARE PROVIDED "AS IS" WITHOUT WARRANTY OR OBLIGATION OF SUPPORT OR
' MAINTENANCE.
'
' ****************************************************************************

' This is a simple Data Export script that uses the IadsDataFileinterface API
' It reads a specified parameter data file and exports a given number of those
' values to a CSV file named <parameter name>.csv.
' -1 can be used to denote that data should be exported from the beginning of the data file.

'IADS data formats
Const IadsInt32Type = 0
Const IadsUnsignedInt32Type = 1
Const IadsFloat32Type = 2
Const IadsInt64Type = 3
Const IadsUnsignedInt64Type = 4
Const IadsFloat64Type = 5
'Const IadsAsciiType = 6
Const IadsBlobType = 7

Dim DataFile
Dim gFSO
Dim gFile

Option Explicit

Private Const BIF_RETURNONLYFSDIRS = 1
Private Const BIF_DONTGOBELOWDOMAIN = 2
Private Const MAX_PATH = 260

Private Declare Function SHBrowseForFolder Lib _
"shell32" (lpbi As BrowseInfo) As Long

Private Declare Function SHGetPathFromIDList Lib _
"shell32" (ByVal pidList As Long, ByVal lpBuffer _
As String) As Long

Private Declare Function lstrcat Lib "kernel32" _
Alias "lstrcatA" (ByVal lpString1 As String, ByVal _
lpString2 As String) As Long

Private Type BrowseInfo
   hWndOwner As Long
   pIDLRoot As Long
   pszDisplayName As Long
   lpszTitle As Long
   ulFlags As Long
   lpfnCallback As Long
   lParam As Long
   iImage As Long
End Type


Private Sub Command1_Click()
  If (Len(directoryTxt.Text) = 0) Then
    MsgBox ("Please enter a data directory.")
  ElseIf (Len(paramTxt.Text) = 0) Then
    MsgBox ("Please enter the name of a parameter to read data from.")
  ElseIf (Len(startTimeTxt) = 0) Then
    MsgBox ("Please enter a start time.")
  ElseIf (Len(numPtsTxt.Text) = 0) Then
    MsgBox ("Please enter the number of points to read.")
  ElseIf (IsNumeric(numPtsTxt.Text) <> True) Then
    MsgBox ("Invalid number of points entered.")
  ElseIf (Len(outputTxt.Text) = 0) Then
    MsgBox ("Please enter an output CSV file name.")
  Else
    ReadParamData (paramTxt.Text)
  End If
End Sub


Private Sub Form_Load()
  Set DataFile = CreateObject("IadsDataFileInterface.DataFile")
End Sub

Sub ReadParamData(ByVal param)
On Error GoTo NoData
DataFile.OpenExisting Trim(directoryTxt.Text), param

On Error GoTo ReadError
Dim startTime
Set startTime = CreateObject("IadsTime.IadsTime")
startTime.TimeString = startTimeTxt.Text

Dim numPoints
numPoints = CInt(numPtsTxt.Text)
If numPoints <= 0 Then
    MsgBox ("Number of data points must be at least 1")
    Exit Sub
End If

' Return value arrays
Dim actualPoints(0 To 1) As Long
Dim irigTime As Variant

Dim dataFormat
dataFormat = DataFile.dataFormat

If (dataFormat = IadsInt32Type) Then
  Dim I32data() As Long
  ReDim I32data(numPoints)
  DataFile.ReadDataI32VB startTime, numPoints, I32data(0), actualPoints(0), irigTime
  
  On Error GoTo WriteError
  WriteDataToCSVFile I32data, irigTime, actualPoints(0)
ElseIf (dataFormat = IadsUnsignedInt32Type) Then
  Dim UI32data() As Double ' No such thing as unsigned 32-bit int in VB
  ReDim UI32data(numPoints)
  DataFile.ReadDataUI32VB startTime, numPoints, UI32data(0), actualPoints(0), irigTime
  
  On Error GoTo WriteError
  WriteDataToCSVFile UI32data, irigTime, actualPoints(0)
ElseIf (dataFormat = IadsFloat32Type) Then
  Dim F32data() As Single
  ReDim F32data(numPoints)
  DataFile.ReadDataF32VB startTime, numPoints, F32data(0), actualPoints(0), irigTime
  
  On Error GoTo WriteError
  WriteDataToCSVFile F32data, irigTime, actualPoints(0)
ElseIf (dataFormat = IadsInt64Type) Then
  Dim I64data() As Variant
  ReDim I64data(numPoints)
  DataFile.ReadDataI64VB startTime, numPoints, I64data(0), actualPoints(0), irigTime
  
  On Error GoTo WriteError
  WriteDataToCSVFile I64data, irigTime, actualPoints(0)
ElseIf (dataFormat = IadsUnsignedInt64Type) Then
  Dim UI64data() As Variant
  ReDim UI64data(numPoints)
  DataFile.ReadDataUI64VB startTime, numPoints, UI64data(0), actualPoints(0), irigTime
  
  On Error GoTo WriteError
  WriteDataToCSVFile UI64data, irigTime, actualPoints(0)
ElseIf (dataFormat = IadsFloat64Type) Then
  Dim F64data() As Double
  ReDim F64data(numPoints)
  DataFile.ReadDataF64VB startTime, numPoints, F64data(0), actualPoints(0), irigTime
  
  On Error GoTo WriteError
  WriteDataToCSVFile F64data, irigTime, actualPoints(0)
ElseIf (dataFormat = IadsBlobType) Then
  Dim blobdata As Variant
  ReDim blobdata(numPoints)
  DataFile.ReadDataBlobVB startTime, numPoints, blobdata, actualPoints(0), irigTime
  
  On Error GoTo WriteError
  WriteDataToCSVFile blobdata, irigTime, actualPoints(0)
Else
  MsgBox ("Error - unrecognized data format found for parameter: " & param)
  Exit Sub
End If

Exit Sub
  
NoData:
  MsgBox ("Could not open data file for parameter '" & param & "' at location " & directoryTxt.Text & _
    ". Make sure the parameter data file exists at that location.")
  Exit Sub
    
ReadError:
  MsgBox ("Error reading data from parameter '" & param & "'")
  Exit Sub
  
WriteError:
  MsgBox ("Error writing parameter data to CSV file. Make sure you have the appropriate permissions at " & outputTxt.Text)
  Exit Sub
    
End Sub
Private Sub WriteDataToCSVFile(ByRef data, ByRef time, ByVal numPoints)
  ' Creates a FileSystemObject we can use to write data to CSV files
  Set gFSO = CreateObject("Scripting.FileSystemObject")

  'Open the file to write to
  Dim outputFile As String
  outputFile = outputTxt.Text + "\" + paramTxt.Text + ".csv"
  Set gFile = gFSO.OpenTextFile(outputFile, 2, True)
  
  ' Write out the file header
  gFile.Write ("TIME," & paramTxt.Text)
  gFile.WriteLine

  ' Write out the data, row by row
  Dim Index
  Dim tempTime As IadsTime
  For Index = 0 To numPoints - 1
    Set tempTime = time(Index)
    gFile.Write (TrimNull(tempTime.TimeString) & "," & data(Index))
    gFile.WriteLine
  Next
  
  'Close the export file
  gFile.Close
  Set gFile = Nothing
  
  MsgBox ("Successfully wrote parameter data '" & paramTxt.Text & "' to CSV file " & outputFile)
  
End Sub
Public Function TrimNull(StrIn As String) As String
  Dim nul As Long
  '
  ' Truncate input string at first null.
  ' If no nulls, perform ordinary Trim.
  '
  nul = InStr(StrIn, vbNullChar)
  Select Case nul
    Case Is > 1
      TrimNull = Left(StrIn, nul - 1)
    Case 1
      TrimNull = ""
    Case 0
      TrimNull = Trim(StrIn)
  End Select
End Function


Private Sub inputBrowseBtn_Click()
    Dim inputPath As String
    inputPath = BrowseForFolder("Select your parameter data directory")
    
    If Len(inputPath) > 0 Then
      directoryTxt.Text = inputPath
    End If
End Sub

Private Sub outputBrowseBtn_Click()
    Dim outputPath As String
    outputPath = BrowseForFolder("Select your CSV file output directory")
    
    If Len(outputPath) > 0 Then
      outputTxt.Text = outputPath
    End If
End Sub

Private Function BrowseForFolder(ByVal dlgText)
    'Opens a Browse Folders Dialog Box that displays the
    'directories in your computer
    Dim lpIDList As Long ' Declare Varibles
    Dim sBuffer As String
    Dim szTitle As String
    Dim tBrowseInfo As BrowseInfo
    
    szTitle = dlgText
    
    With tBrowseInfo
       .hWndOwner = Me.hWnd ' Owner Form
       .lpszTitle = lstrcat(szTitle, "")
       .ulFlags = BIF_RETURNONLYFSDIRS + BIF_DONTGOBELOWDOMAIN
    End With
    
    lpIDList = SHBrowseForFolder(tBrowseInfo)
    
    If (lpIDList) Then
      sBuffer = Space(MAX_PATH)
      SHGetPathFromIDList lpIDList, sBuffer
      sBuffer = Left(sBuffer, InStr(sBuffer, vbNullChar) - 1)
      BrowseForFolder = sBuffer
    End If
End Function
